import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { Splash, SplashParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询开屏广告
 */
export async function pageSplash(params: SplashParam) {
  const res = await request.get<ApiResult<PageResult<Splash>>>(
    MODULES_API_URL + '/shop/splash/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询开屏广告列表
 */
export async function listSplash(params?: SplashParam) {
  const res = await request.get<ApiResult<Splash[]>>(
    MODULES_API_URL + '/shop/splash',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加开屏广告
 */
export async function addSplash(data: Splash) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/splash',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改开屏广告
 */
export async function updateSplash(data: Splash) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/splash',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除开屏广告
 */
export async function removeSplash(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/splash/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除开屏广告
 */
export async function removeBatchSplash(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/splash/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询开屏广告
 */
export async function getSplash(id: number) {
  const res = await request.get<ApiResult<Splash>>(
    MODULES_API_URL + '/shop/splash/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
